/*******************************************************************************
 *
 *        Program : function.h
 *
 *        Author  : Kim, Dongmin (kimd@top.cis.syr.edu)
 *
 *        The functions used in prs.c
 *
 *******************************************************************************/

/** For Active Message Passing **/
int    rport = 32;
int    prs_dim_ack;

/*******************************************************************************
 *   Procedure : prs_dim_handler                                               *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/
void prs_dim_handler() {

  prs_dim_ack = true;

}
/********************************/

show(id, start, size, vector)
     int id, start, size, *vector;
{
  int pn;
  int i;

  CMMD_fset_io_mode(stdout, CMMD_independent);
  for ( pn = 0 ; pn < tot_nproc ; pn++ ) {
    if ( id == pn ) {
      printf("***********************************************\n");
      printf("Processor %2d =>  ", id);
	  
      for ( i = start ; i < start+size ; i++ )
	printf("%d  :  %3d\n", i, vector[i]);

      printf("***********************************************\n");
      fflush(stdout);
    }

    CMMD_sync_with_nodes();
  }
}

show2(id, partner, start, size, check, in_mesg)
     int id, partner, start, size, check, *in_mesg;
{
  int pn;
  int i;

  CMMD_fset_io_mode(stdout, CMMD_independent);
  for ( pn = 0 ; pn < tot_nproc ; pn++ ) {
    if ( id == pn ) {
      printf("***********************************************\n");
      printf("Processor %2d   Partner %2d   check %d\n", id, partner, check);
      for ( i = start ; i < start+size ; i++ )
	printf("%d  :  %3d\n", i, in_mesg[i]);

      printf("***********************************************\n");
      fflush(stdout);
    }

    CMMD_sync_with_nodes();
  }
}

show3(id, digit, size, Right)
     int id, digit, size, Right[Max][Max];
{
  int pn ;
  int i, j, k, temp_size;

  CMMD_fset_io_mode(stdout, CMMD_independent);

  temp_size = size;
  for ( pn = 0 ; pn < tot_nproc ; pn++ ) {
    if ( id == pn ) {
      printf("***********************************************\n");
      printf("Processor %2d   \n", id);
      for ( i = 0 ; i < digit ; i++ ) {
	for ( j = 0 ; j < v_size ; j++ ) {
	  printf("Right[%d][%d]  :  %3d\n", i, j, Right[i][j]);
	  temp_size = temp_size / 2;
	}
      }

      printf("***********************************************\n");
      fflush(stdout);
    }

    CMMD_sync_with_nodes();
  }
}

show4(id, ch, value)
     char* ch;
     int value, id;
{

  int    pn;

  CMMD_fset_io_mode(stdout, CMMD_independent);

  for ( pn = 0 ; pn < tot_nproc ; pn++ ) {
    if ( id == pn ) {
      printf("***********************************************\n");
      printf("Processor %2d   \n", id);
	  printf("%s : %d\n", ch, value);

      printf("***********************************************\n");
      fflush(stdout);
    }

    CMMD_sync_with_nodes();
  }
}

/*******************************************************************************
 *   Procedure : Ilog2()                                                       *
 *   Input     : int n                                                         *
 *   Output    : log2(n)                                                       *
 *   Function  : return the integer value of log2(n) if it is integer.         *
 *               If not, return -1.                                            *
 *******************************************************************************/
int Ilog2(n)
     int n;
{
  int i = 0;
  int n1 = n;

  if ( n < 1 ) return -1;

  while ( n1 >>= 1 )
    ++i;

  if ( 1 << i != n )
    return -1;
  else
    return i;
}

/*******************************************************************************
 *   Procedure : pow2()                                                        *
 *   Input     : int x                                                         *
 *   Output    : 2^x                                                           *
 *   Function  : power of 2 for the input value                                *
 *******************************************************************************/
int pow2(x)
     int x;
{
  int p = 1;
  int i;

  for ( i = 0 ; i < x ; i++ )
    p <<= 1;

  return p;
}
